define procedure change_size (x%,y%)
rem this changes the size of a typical window with my typical global variables.
rem it relies on the window being made in a procedure called make_main_window.
rem params : pointer x & y positions relative to wdw origin
rem global vars used: main_lfl% (loose items flag array), main_cty% (ctrl defn)
rem size_it% (size item index into main_lfl%), main_defn,xsize%,ysize%,
rem main_mfl%,main_lit%,maxx%,maxy%,rows%
rem minx%,miny%
local xrel%,yrel%,ttemp%(main_lit%),xabs%,yabs%,temp%,b$
  main_lfl%(size_it%)=1 		: remark reset to available
  arrcopy main_lfl%,ttemp%		: remark keep statusses
  ch_win main_defn,xrel%,yrel%		: remark ptr displacement
  xsize%=xsize%-xrel%+3
  ysize%=ysize%-yrel%			: remark new sizes
  rows%=-1				: rem nbr of rows depends on wdw size
  temp%=2^4+2^5
  rptr xabs%,yabs%,temp%,temp%,xrel%,yrel%,bt$: remark get absolute coords
  if xsize%>maxx%-16:xsize%=maxx%-16
  if ysize%>maxy%-16:ysize%=maxy%-16	: remark max values
  if xsize%<minx%-16:xsize%=minx%
  if ysize%<miny%-16:ysize%=mniy%	: remark minimum size
  dr_unst main_defn			: remark no more wdw defn...
  dr_remv main_defn			: remark .... now!  (releases all mem)
  make_main_window			: remark make window anew
  arrcopy ttemp%,main_lfl%
rem  xabs%=xabs%-t%:if xabs%<0:xabs%=0	   : remark position ptr nicely
rem  yabs%=yabs%-8:if yabs%<0:yabs%=0
rem  sptr xabs%,yabs%,0 		   : remark now
  if compiled
     dr_ppos main_defn,-1,-1,main_lfl%,main_mfl%,main_cty%
  else
     dr_puld main_defn,-1,-1,main_lfl%,main_mfl%,main_cty%
  end if
  pos_ptr main_defn,x%*65536+y%,1	: remark position pointer in wdw
end define change_size
:
