def proc do_popup(string$)
rem this pops up a small "hint" window showing the string$ passed
rem as parameter.
rem The string MUST be 1 line long and MUST fit
rem inside the window (YOU must make sure of that!)
  do_popup2 string$,0
end def do_popup
:
def proc popup_make
rem make a small window defn
local x%,y%,p_iot,p_iwt
  restore
  p_sprt=rd_sprt(0)			: rem make an invisible pointer, all transparent
    data 1,2,0,0,4
    data '  '
  x%=14 				: rem bogus window sizes
  y%=10
  p_iwt=rd_iwt(0)			: rem the info wdw
    DATA x%,y%,0,0
    DATA 0,0, sp.hintbd,sp.hintbg
    DATA 0
  popup_defn=RD_WDEF			: rem the working defn
    DATA 0,1,sp.hintbd,sp.hintbg	: rem no shadow, border size & col, paper col
    DATA x%,y%,40,2
    DATA p_sprt,0,p_iwt,0
end def popup_make
:
def proc do_popup2(string$,main_defn)
rem This pops up a small "hint" window showing the string$ passed
rem as parameter.
rem main_defn is the working defintion of the window over which the hint
rem window is to hover. Position the pointer there where you need it before
rem calling this.
rem If the string is too long to fit into the window (which can only be as long
rem as the outline of the working defn) then the string is split up at the
rem first convenient space and put on a second line, and so on.
rem If this would lead to the hint window being too high, only as many
rem lines as possible will be displayed.
rem !!!!!
rem This presumes that a char is 10 pixels high & 6 pixels wide (standard ql 6x10 matrix)..
rem !!!!!
rem The string may contain the char chr$(10) - there will be a newline.
rem
rem note : do not try to pass a screen chaneel, you MUST open & close one here.
rem
local dummy%,lp%,address,dummy_array%(0),xa%,ya%,con%,da%(3),temp%,lastspace%
local hint$(10),slen% ,maxlength%
  if string$="":return			: rem empty string, do nothing
  string$=strip_spaces$(string$)	: rem no spaces at ends
  con%=fopen("con")
  if main_defn<>0
    xs%=peek_w (main_defn+32)
    ys%=peek_w(main_defn+34)		: rem get max sizes the hint wdw may have
  else
    scr_size#con%,xs,ys%
  endif
  xs%=(xs%-4) div 6			: rem max nbr of chars in 1 line
  ys%=(ys%-4) div 10			: rem max nbr of lines in wdw
  if xs%=0 or ys%=0:close#con%:return	: rem nothing will really fit, just leave
  dim hint$(ys%,xs%)			: rem array to contain string
  rem now parse the string, find newlines, make sure of string length
  dummy%=1				: rem start of current string section
  temp%=0				: rem line
  slen%=0				: rem current length of string
  for lp%=1 to len(string$)
    if string$(lp%)=chr$(10)
      hint$(temp%)=string$(dummy% to lp%-1): rem cut string here
      temp%=temp%+1
      if temp%=ys%:exit lp%		: rem max nbr of lines reached
      dummy%=lp%+1			: rem this is where new start of string is
      lastspace%=lp%
    else
      if string$(lp%)=" "
	lastspace%=lp%			: rem this is where last space is
      endif
    endif
    slen%=slen%+1			: rem one more char
    if slen% > xs%
      hint$(temp%)=string$(dummy% to lastspace%-1) : rem too many chars in line
      slen%=0
      temp%=temp%+1			: rem we need nother line
      if temp%=ys%:exit lp%		: rem max nbr of lines reached
      dummy%=lastspace%+1
    endif
  end for lp%
  if temp%<ys%
     hint$(temp%)=string$(dummy% to)	   : rem add last part
     temp%=temp%+1
  endif
  maxlength%=0
  for lp%=0 to temp%
    if maxlength%<len(hint$(lp%)):maxlength%=len (hint$(lp%))
  end for lp%
  lp%=(maxlength%*6)+4			: rem hint window length
  poke_w popup_defn+32,lp%		: rem set window xsize
  poke_w popup_defn+34,temp%*10+2	: rem
  address=peek_l(popup_defn+100)	: rem ptr to info sub wdw
  poke_w address,lp%-2			: rem set its length
  poke_w address+2,temp%*10		: rem set its height
  dr_puld popup_defn,-1,-1,dummy_array%
  dr_iwdf#con%,popup_defn,0		: rem pull wdw over info wdw
  wm_paper#con%,sp.hintbg
  wm_ink#con%,sp.hintfg
  wsipo#con%,da%			: rem get wdw size & origs
  outln#con%,da%(0),da%(1),da%(2),da%(3): rem and use them to set outline
  for lp%=0 to dimn(hint$,1)
    if hint$(lp%)<>"":print#con%,hint$(lp%)
  end for lp%
  swdef#con%,-1,da%(0),da%(1),da%(2),da%(3),p_sprt : rem and set sprite
  sptr#con%,da%(2)+2,da%(3)+2,2
  rptr#con%, xa%,ya%,48,dummy%,dummy%,dummy%,dummy$ : rem get absolute ptr position
  rptr#con%, xa%,ya%,11, dummy%,dummy%,dummy%,dummy$: rem return on pointer move
  close#con%
  dr_unst popup_defn			: rem and off we go
end def do_popup2
:
